#include <pch.h>

std::shared_ptr<Window> Backend::window;

void Backend::ReplaceWindow(const char* title, int width, int height) {
    window = std::make_shared<Window>(title, width, height);
}

void Backend::Init(const char* title, int width, int height) {
    glfwSetErrorCallback(Callbacks::GLFWError);
    glfwInit();

    glfwWindowHint(GLFW_CONTEXT_VERSION_MAJOR, 4);
    glfwWindowHint(GLFW_CONTEXT_VERSION_MINOR, 6);
    glfwWindowHint(GLFW_OPENGL_PROFILE, GLFW_OPENGL_CORE_PROFILE);

    ReplaceWindow(title, width, height);

    gladLoadGLLoader((GLADloadproc)glfwGetProcAddress);
    glDebugMessageCallback(Callbacks::OpenGLMessage, nullptr);
}

const std::shared_ptr<Window>& Backend::GetWindow() {
    return window;
}
