#include <pch.h>

std::unordered_set<int> Input::pressed_keys;
std::unordered_set<int> Input::released_keys;
const std::shared_ptr<Window>& Input::window = Backend::GetWindow();

bool Input::IsKeyDown(int key) {
    return window->IsKeyDown(key);
}

bool Input::IsKeyUp(int key) {
    return window->IsKeyUp(key);
}

bool Input::IsKeyPressed(int key) {
    if(IsKeyUp(key)) {
        if(pressed_keys.contains(key)) {
            pressed_keys.erase(key);
        }

        return false;
    }

    if(pressed_keys.contains(key)) {
        return false;
    } else {
        pressed_keys.insert(key);
        return true;
    }
}

bool Input::IsKeyReleased(int key) {
    if(IsKeyDown(key)) {
        if(!released_keys.contains(key)) {
            released_keys.insert(key);
        }

        return false;
    }

    if(!released_keys.contains(key)) {
        return false;
    } else {
        released_keys.erase(key);
        return true;
    }
}
