#include <pch.h>

Window::Window(const char* title, int width, int height) {
    window = glfwCreateWindow(width, height, title, nullptr, nullptr);
    glfwMakeContextCurrent(window);
}

Window::~Window() {
    std::cout << "freeing window" << std::endl;
    glfwDestroyWindow(window);
}

bool Window::ShouldClose() {
    return glfwWindowShouldClose(window);
}

void Window::SwapBuffers() {
    glfwSwapBuffers(window);
}

bool Window::IsKeyDown(int key) {
    return glfwGetKey(window, key) == GLFW_PRESS;
}

bool Window::IsKeyUp(int key) {
    return glfwGetKey(window, key) == GLFW_RELEASE;
}

void Window::SetVSync(bool enabled) {
    glfwSwapInterval(enabled);
}
